module core.animatable;

private import std.stdio;

//private import opengl;


enum AnimType
{
	EMPTY,
	LINEAR,//animate to an absolute target e.g. x to 500.
	LINEAR_RELATIVE, //animate relatively e.g. 500 units to the left.
	BSPLINE,
	BSPLINE_RELATIVE
}

class AnimationData
{
	public:

		this()
		{
			
		}

		bool idle()
		{
			
			//switch( m_animType ) TODO

			//writefln("animatable.idle() START.");
			if( *m_data < m_target && m_speed > 0.0 )
			{
				////////////m_reDraw();//invalidate the old position.
				//writefln("updating + m_data.");
				*m_data += m_speed;
				////////////m_reDraw();//invalidate the new position.
				
				if( *m_data >= m_target )//could we make this into an unittest, and would that help??
				{
					m_animType = AnimType.EMPTY;
					////////////////NO delete m_timeout;
					return false;
				}
			}
			else if( *m_data > m_target && m_speed > 0.0 )
			{	
				////////////m_reDraw();
				//writefln("updating - m_data.");
				*m_data -= m_speed;
				///////////m_reDraw();
				
				if( *m_data <= m_target )
				{
					m_animType = AnimType.EMPTY;
					////////////////NO delete m_timeout;
					return false;
				}
			}
			//else
			//{
				//just a test: 
				//m_target *= -0.9;
				//m_speed *= -0.9;
			
				//m_animType = AnimType.EMPTY;
				////////////////NO delete m_timeout;
				//return false;
			//}
			
			return true;//continue
		}

			
		float* m_data;
		float m_target;
		float m_speed = 1.0;
		AnimType m_animType = AnimType.EMPTY;
		//Timeout m_timeout;
		///////void delegate() m_reDraw;
}

class Animatable
{
	//Contains mostly functions to animate doubles with Gtk.timers and/or timeouts???.

	public:

		this()
		{
			m_animationData = new AnimationData[10];
			for( uint i = 0; i < m_animationData.length; i++ )
				m_animationData[i] = new AnimationData();
		}

		void idle()
		{
			for( uint i = 0; i < m_animationData.length; i++)
			{
				//writefln("going through animadatas. i=",i);
				if( m_animationData[i] !is null && m_animationData[i].m_animType != AnimType.EMPTY )
				{
					//writefln("found empty.");
					m_animationData[i].idle();
				}
				//else debug(0) writefln("this is not empty.");
			}

		}

		//This is for 2 numbers at the same time, usefull for moving stuff.
		//void animate( float* x_me, float* y_me, float x_to, float y_to, float speed = 1.0, AnimType animType = AnimType.LINEAR )

		void animate( float* me, float to, float speed = 1.0, AnimType animtype = AnimType.LINEAR )
		{
			//debug(0) writefln("animate() START.");
			if( me !is null )
			{
				//writefln("animatable float is ok.");
				AnimationData animData = getEmptyAnimationData();
				if( animData !is null )
				{
					animData.m_data = me;
					animData.m_target = to;
					animData.m_speed = speed;
					animData.m_animType = animtype;
					//animData.m_reDraw = &reDraw;
					//animData.m_timeout = new Timeout( 10, &animData.idle, false );
				}
				else debug(0) writefln("getEmptyAnimationData failed...");
			}
		}
		
		/*void reDraw()
		{
			debug(0) writefln("Animatable.reDraw.. should be defined when inherited.");
		}*/

	protected:
		AnimationData getEmptyAnimationData()
		{
			debug(1) writefln("getEmptyAnimationData() START.length: ", m_animationData.length);
			uint i;
			for( i = 0; i < m_animationData.length; i++)
			{
				//writefln("going through animadatas. i=",i);
				if( m_animationData[i] !is null && m_animationData[i].m_animType == AnimType.EMPTY )
				{
					//writefln("found empty.");
					return m_animationData[i];
				}
				//else debug(0) writefln("this is not empty.");
			}
			if( i >= m_animationData.length )
			{
				debug(0) writefln("should resize.");
				//resize...
			}
			debug(0) writefln("getEmptyAnimationData failed... END.");
			return null;
		}
		
		AnimationData[] m_animationData;
}
