module core.image;

import tango.io.Stdout;

import tango.io.File;
import tango.io.FileConduit;
import tango.io.FilePath;

import derelict.opengl.gl;
import derelict.opengl.glu;

class Image// : public basic_object
{
public:
	this()
	{
		//cout<<"\npuImage::Init()"<<c_str();
		texFormat = GL_RGB;
		imageWidth = 0;
		imageHeight = 0;
		imageBits = 0;
		size = 0;
	}
	
	this(char[] filename)
	{
		this();
		loadTGA(filename);
	}
	
	~this()
	{
		freeMemory();
	}

	void freeMemory(){}


	bool loadTGA(char[] filename)
	{
		//returns true if ok and false if failed
		
		Stdout("Image.loadTGA:")(filename);
		
		//if( imageData.empty() )
		//	imageData.erase(imageData.begin(), imageData.end() );
		
			//delete imageData;
		
		FilePath file_path = new FilePath(filename);
		auto conduit = new FileConduit( file_path, FileConduit.ReadExisting );
		scope(exit) conduit.close();
		
		//ifstream tluku; //luo virta
		
		//tluku.open(filename.c_str(),ios::in | ios::nocreate | ios::binary);
		/*if( tluku.fail() )
		{
			cout<<"\nTGA_FILE_NOT_FOUND: "<<filename;
			tluku.close();
			return 0;
		}*/
		
		conduit.input.read( type );
		conduit.seek( 12 );//from Seek.Anchor.Begin
		conduit.input.read( info );
		
		conduit.seek( 0 );//from Seek.Anchor.Begin
		conduit.input.read( tgaheader );
		
/*		
		tluku.read( (char *) &type, 3);
		tluku.seekg(sizeof (char) * 12, ios::beg);
		tluku.read( (char *) &info, 6);
		
		//READ the complete header too
		tluku.seekg(sizeof (char) * 0, ios::beg);
		tluku.read( (char *) &tgaheader, 18);
*/	
		printHeader();
		
		//assert(0);
		
		if (type[1] != 0 || (type[2] != 2 && type[2] != 3))
		{
			//type[1]: 0 means no color mapping, 1 means color mapping
			//color mapping isn't supported
			/* type[2]:
			0  -  No image data included.
			1  -  Uncompressed, color-mapped images.
			2  -  Uncompressed, RGB images. //this is supported
			3  -  Uncompressed, black and white images. //this is supported
			9  -  Runlength encoded color-mapped images.
			10  -  Runlength encoded RGB images.
			11  -  Compressed, black and white images.
			32  -  Compressed color-mapped data, using Huffman, Delta, and
							runlength encoding.
			33  -  Compressed color-mapped data, using Huffman, Delta, and
							runlength encoding.  4-pass quadtree-type process.
			*/
			Stdout("TGA_BAD_IMAGE_TYPE: ")(filename).newline;
			//tluku.close();
			return false;
		}
		
		imageWidth = info[0] + info[1] * 256;
		imageHeight = info[2] + info[3] * 256;
		imageBits =	info[4];
		
		size = imageWidth * imageHeight;
		
		
		// make sure dimension is a power of 2
		//if (!CheckSize (imageWidth) || !CheckSize (imageHeight))
			//	cout<<"\nTGA_BAD_IMAGE_WIDTH/HEIGHT: "<<filename;
		Stdout("image width: ")(imageWidth)(" height: ")(imageHeight).newline;
		
		// make sure we are loading a supported type
		if (imageBits != 32 && imageBits != 24 && imageBits != 8)
		{
			Stdout("TGA_BAD_OR_UNSUPPORTED_BITS: ")(filename)(" has ")(imageBits)(" bits").newline;
			//tluku.close();
			return false;
		}
		else Stdout("image bits: ")(imageBits).newline;
		
		
		if (imageBits == 32)
		{
			int i;
			int bread;
			GLubyte temp;
		
			/*for(int i = 0; i < size * 4; i++)
			{
				char toread;
				tluku.read( (char *) &toread, sizeof(char) );
				imageData.insert(imageData.end(), (GLubyte)toread);
			}
		
			bread = tluku.gcount();
		
			if (bread != size * 4)
				{
				cout<<"\nTGA_MEMORY_PROBLEM: "<<filename;
				return 0;
				}
			*/
			
			imageData = new GLubyte[size*4];
			
			conduit.input.read( imageData );
			
			// TGA is stored in BGR, make it RGB
			//swap R & B
			swapBR();
		
			//cout<<"\nImage format: RGBA";
			texFormat = GL_RGBA;
		}
		else if (imageBits == 24)
		{
			int i;
			int bread;
			GLubyte temp;
		
			/*for(int i = 0; i < size * 3; i++)
			{
				if(i%10000 == 0) cout<<"\nReading TGA data:"<<i<<" of "<<size*3;
				char toread;
				tluku.read( (char *) &toread, sizeof(char) );
				imageData.insert(imageData.end(), toread);
			}
		
			cout<<"\nTGA data read";
		
			bread = tluku.gcount();
		
			if (bread != size * 3)
				{
				cout<<"TGA_MEMORY_PROBLEM: "<<filename;
				return 0;
				}
			*/
			
			imageData = new GLubyte[size*3];
			
			conduit.input.read( imageData );
			
			//cout<<"\nImage format: RGB";
				texFormat = GL_RGB;
		
			//cout<<"\nTGA data OK";
			// TGA is stored in BGR, make it RGB
			swapBR();
		
		}
		
		else if (imageBits == 8)
		{
			int bread;
		
			/*for(int i = 0; i < size; i++)
			{
				char toread;
				tluku.read( (char *) &toread, sizeof(char) );
				imageData.insert(imageData.end(), toread);
			}
		
			bread = tluku.gcount();
		
			if (bread != size)
				{
				cout<<"TGA_MEMORY_PROBLEM: "<<filename;
				return 0;
				}
		
			cout<<"\nImage format: only Alpha";
			*/
			
			imageData = new GLubyte[size];
			
			conduit.input.read( imageData );
			
			texFormat = GL_ALPHA;
		}
		
		// no image data
		/*if (imageData.empty() )
		{
			cout<<"TGA_BAD_DATA: "<<filename;
			tluku.close();
			return 0;
		}
		
		tluku.close();*/
		
		//MakeBorders();
		
		//PrintHeader();
		
		return true;
	}
	
	bool writeTGA(char[] filename)
	{
		//returns true if ok and false if failed
		
		//Stdout("Image::writeTGA() START.")(filename).newline;
		
		if( imageData is null || imageData.length == 0 )
		{
			Stdout("No data : imagedata is empty.").newline;
			return false;
		}
		
		//ofstream tulos; //luo virta
		scope File file = new File(filename);
		
		//tulos.open(filename.c_str(), ios::out | ios::noreplace | ios::binary);
		/*if( tulos.fail() )
		{
			char over = 'n';
			cout<<"\nFILE allready EXISTS: "<<filename<<"\nOverWrite(y/n)";
			cin>>over;
			if(over == 'y' || over == 'Y')
			{
				tulos.open(filename.c_str(), ios::out | ios::trunc | ios::binary);
				if(tulos.fail())
				{
				cout<<"\nfile overwriting didn't work for some reason";
					tulos.close();
				return 0;
				}
			}
			else
			{
				cout<<"\nfile not saved - try again with a different filename";
				tulos.close();
			return 0;
			}
		}*/
		
		//WRITING:
		
		//swapBR();
		swapRG();
		
		/*Negative:
		for(uint i = 0; i < imageData.length; i++)
		{
			imageData[i] = 255 - imageData[i];
		}*/
	
		//PrintHeader();
		
		//tulos.write( (char *) &tgaheader, 18);
		
		file.write( tgaheader );
		
		int times = 0;
		if(imageBits == 32) times = 4;
		else if(imageBits == 24) times = 3;
		else if(imageBits == 8) times = 1;
		else
		{
			Stdout("file not saved - wrong imageBits:")(imageBits).newline;
			//tulos.close();
			return 0;
		}
	
		file.append( imageData );
		
		/*for(int i = 0; i < (size * times); i++)
		{
		char towrite;
			towrite = imageData[i];
			tulos.write( (char *) &towrite,  sizeof (char) );
		}*/
	
	
		//tulos.close();
		swapBR();
		Stdout("...file writing succeeded").newline;
		return true;
	}
	
	void swapBR()
	{
		int times = 0;
		if(imageBits == 32) times = 4;
		else if(imageBits == 24) times = 3;
		else
		{
			Stdout("can't swap one channel TGA").newline;
			return;
		}
	
		GLubyte temp;
	
		for (int i = 0; i < (size * times); i += times )
		{
			temp = imageData[i]; //t = B
			imageData[i] = imageData[i + 2]; //B = R
			imageData[i + 2] = temp; //R = t(B)
		}
		return;
	}
	
	void swapRG()
	{
		int times = 0;
		if(imageBits == 32) times = 4;
		else if(imageBits == 24) times = 3;
		else
		{
			Stdout("can't swap one channel TGA").newline;
			return;
		}
	
		GLubyte temp;
	
		for (int i = 0; i < (size * times); i += times )
		{
			temp = imageData[i]; //t = R
			imageData[i] = imageData[i + 1]; //R = G
			imageData[i + 1] = temp; //G = t(R)
		}
		return;
	}
	
	//void render();
	/*
	void unify(Image pic)
	{
   cout<<"\npuImage::Unify()";

   if (&pic == this)
   {
   	cout<<"...FAILED trying to unify Image to itself";
   	return;
   }
   texFormat = pic.texFormat;
   strcpy((char*)type, (char*)pic.type);
   strcpy((char*)info, (char*)pic.info);
   strcpy((char*)tgaheader, (char*)pic.tgaheader);

   imageWidth = pic.imageWidth;
   imageHeight = pic.imageHeight;

   imageBits = pic.imageBits;

   size = pic.size;

   //cout<<"\nR: "<<imageData[0];
   //cout<<"\nG: "<<imageData[1];
   //cout<<"\nB: "<<imageData[2];
   //cout<<"\nA: "<<imageData[3];

	if (imageData.empty() || pic.imageData.empty() )
   {
      	cout<<"\nTGA_No memory in this Image for unify -- imageData == NULL";
         return;
   }

   int maxcol = 255;

	if (imageBits == 32)
   {
      for(int i = 0; i < (size * 4); i+=4)
      {
      	if(pic.imageData[i] < maxcol && pic.imageData[i+1] < maxcol && pic.imageData[i+2] < maxcol)
         {
         	imageData[i] = PlusColor(imageData[i], pic.imageData[i]); //R
            imageData[i+1] = PlusColor(imageData[i+1], pic.imageData[i+1]); //G
            imageData[i+2] = PlusColor(imageData[i+2], pic.imageData[i+2]); //B
            imageData[i+3] = PlusColor(imageData[i+3], pic.imageData[i+3]); //A
         }
      }

   }
   else if (imageBits == 24)
   {
 	   for(int i = 0; i < (size * 3); i+=3)
      {
      	if(pic.imageData[i] < maxcol && pic.imageData[i+1] < maxcol && pic.imageData[i+2] < maxcol)
         {
         	imageData[i] = PlusColor(imageData[i], pic.imageData[i]); //R
            imageData[i+1] = PlusColor(imageData[i+1], pic.imageData[i+1]); //G
            imageData[i+2] = PlusColor(imageData[i+2], pic.imageData[i+2]); //B
         }
      }
   }
   else if (imageBits == 8)
   {
      for(int i = 0; i < size; i++)
      {
      	if(pic.imageData[i] < maxcol)
         {
         	imageData[i] = PlusColor(imageData[i], pic.imageData[i]); //A
         }
      }
   }

  //PrintHeader();
	return;
}

*/
	
/*	
	void copy(Image pic)
	{
	cout<<"\npuImage::Copy()";
   if (&pic == this)
   {
   	cout<<"...FAILED trying to copy Image to itself";
   	return;
   }
   texFormat = pic.texFormat;
   strcpy((char*)type, (char*)pic.type);
   strcpy((char*)info, (char*)pic.info);
   strcpy((char*)tgaheader, (char*)pic.tgaheader);

   imageWidth = pic.imageWidth;
   imageHeight = pic.imageHeight;

   imageBits = pic.imageBits;

   size = pic.size;



   FreeMemory();

   imageData = pic.imageData;

   //MakeBorders();

   return;
}

*/
	void clear(GLubyte value = 0)
	{
		if ( imageData is null || imageData.length == 0 )
		{
			Stdout("TGAbadData in this Image for clear() -- imageData empty").newline;
			return;
		}
		int times = 0;
		
		if (imageBits == 32) times = 4;
		else if (imageBits == 24) times = 3;
		else if (imageBits == 8) times = 1;
		else
		{
			Stdout("TGA_Bad imagebits: ")(imageBits).newline;
			return;
		}
	
		for(int i = 0; i < (size*times); i++)
		{
			imageData[i] = value;
		}
	
		//makeBorders();
	
		return;
	}
	void colorize(GLubyte r,GLubyte g,GLubyte b )
	{
		if ( imageData is null || imageData.length == 0 )
		{
			Stdout("TGAbadData in this Image for Colorize -- imageData empty").newline;
			return;
		}
		
		int times = 0;
	
		if (imageBits == 32) times = 4;
		else if (imageBits == 24) times = 3;
		else if (imageBits == 8)
		{
			times = 1;
			Stdout("can't colorize 8 bit - one color channel images").newline;
			return;
		}
		else
		{
			Stdout("TGA_Bad imagebits: ")(imageBits).newline;
			return;
		}
		
		GLubyte maxcol = 255;
		
		for(int i = 0; i < (size * times); i+=times)
		{
			if(imageData[i] < maxcol && imageData[i+1] < maxcol && imageData[i+2] < maxcol)
			{
				imageData[i] = r;//PlusColor(imageData[i], r);//R
				imageData[i+1] = g;//PlusColor(imageData[i+1], g); //G
				imageData[i+2] = b;//PlusColor(imageData[i+2], b); //B
			}
		}
	
		return;
	}

/*
	//void makeBorders()
	{
		if (imageData.empty() )
		{
				cout<<"\nTGA_No memory in this Image for MakeBorders -- imageData == NULL";
				return;
		}
		
			if (imageBits == 32)
		{
		}
		else if (imageBits == 24)
		{
			//ala viiva:
		
			for(int i = 0; i < (imageWidth*3); i+=3)
			{
				imageData[i] = 0;
				imageData[i+1] = 0;
				imageData[i+2] = 0;
				//imageData[i+3] = 0;
			}
		
			//yl� viiva:
		
			//putpixel:
			//imageData[(y * imageWidth) + x] = color
		
			for(int x = 0; x < (imageWidth*3); x+=3)
			{
				imageData[ ((imageWidth*3)*(imageHeight-1))+ x] = 0;
				imageData[ ((imageWidth*3)*(imageHeight-1))+ x+1] = 0;
				imageData[ ((imageWidth*3)*(imageHeight-1))+ x+2] = 0;
			}
		
			//vasen sivu
		
			for(int y = 0; y < (imageHeight-1); y++)
			{
				imageData[ ((imageWidth*3)*y)+ 0] = 0;
				imageData[ ((imageWidth*3)*y)+ 1] = 0;
				imageData[ ((imageWidth*3)*y)+ 2] = 0;
			}
		
			//oikea sivu
		
			for(int y = 0; y < (imageHeight-1); y++)
			{
				imageData[ ((imageWidth*3)*y)+ ((imageWidth-1)*3) ] = 0;
				imageData[ ((imageWidth*3)*y)+ (((imageWidth-1)*3)+1)] = 0;
				imageData[ ((imageWidth*3)*y)+ (((imageWidth-1)*3)+2)] = 0;
			}
		
		
		}
		else if (imageBits == 8)
		{
		}
		
		
		
		}
	
*/
	
	//EXCEPTIONS:

	/*class TgaError {};
	class TgaFileNotFound : public TgaError {};
	class TgaBadImageType : public TgaError {};
	class TgaBadDimension : public TgaError {};
	class TgaBadBits : public TgaError {};
	class TgaBadData : public TgaError {};*/


protected:

	//LOAD HELPERS:
	bool checkSize (int x)
	{
		if (x == 2	 || x == 4 ||
			x == 8	 || x == 16 ||
			x == 32  || x == 64 ||
			x == 128 || x == 256 || x == 512)
			return true;
		//else 
		return false;
	}
	//void swapBR();

/*
	GLubyte plusColor(GLubyte eka, GLubyte toka)
	{
		int tulos = eka - toka;
		
		// 60 - 15 = 45
		
		if(eka == toka)
			return eka;
		
		if(eka >= toka)
		{
			if(toka >= tulos)
				return toka - tulos;
			else return 0;
		}
		else // 15 - 60 = -45
		{
			if(eka >= tulos)
				return eka + tulos;
			else return 0;
		}
		
		cout<<"\nERROR PlusColor got to the end!";
		return 255;
	}
*/

	void printHeader()
	{
		Stdout("TGA header: ")//<<hex<<
		(cast(int)tgaheader[0])(" ")
		(cast(int)tgaheader[1])(" ")
		(cast(int)tgaheader[2])(" ")
		(cast(int)tgaheader[3])(" ")
		(cast(int)tgaheader[4])(" ")
		(cast(int)tgaheader[5])(" ")
		(cast(int)tgaheader[6])(" ")
		(cast(int)tgaheader[7])(" ")
		(cast(int)tgaheader[8])(" ")
		(cast(int)tgaheader[9])(" ")
		(cast(int)tgaheader[10])(" ")
		(cast(int)tgaheader[11])(" ")
		(cast(int)tgaheader[12])(" ")
		(cast(int)tgaheader[13])(" ")
		(cast(int)tgaheader[14])(" ")
		(cast(int)tgaheader[15])(" ")
		(cast(int)tgaheader[16])(" ")
		(cast(int)tgaheader[17])(" ")
		(cast(int)tgaheader[18])(" ").newline;
		//<<dec;
	}
public:
	GLenum texFormat; //GL_RGBA,GL_RGB,GL_ALPHA

	GLubyte[4] type;
	GLubyte[7] info;

	GLubyte[19] tgaheader;

public:
	//REAL DATA:
	public GLubyte[] imageData;
	int imageWidth, imageHeight;
	int imageBits, size;
}

